'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = futureMiddleware;

var _fluxStandardAction = require('flux-standard-action');

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

var isObject = function isObject(value) {
  return value && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && (value.__proto__ == null || value.__proto__ === Object.prototype);
};

function isFuture(val) {
  return val && typeof val.fork === 'function';
}

function futureMiddleware(_ref) {
  var dispatch = _ref.dispatch;

  return function (next) {
    return function (action) {
      if (!(0, _fluxStandardAction.isFSA)(action)) {
        return isFuture(action.future) ? action.future.fork(function (error) {
          return dispatch(_extends({}, action, error));
        }, function (result) {
          var resultObj = isObject(result) ? result : { result: result };
          delete action.future;
          dispatch(_extends({}, action, resultObj));
        }) : next(action);
      }

      return isFuture(action.payload) ? action.payload.fork(function (error) {
        return dispatch(_extends({}, action, { payload: error, error: true }));
      }, function (result) {
        return dispatch(_extends({}, action, { payload: result }));
      }) : next(action);
    };
  };
}